import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

//import javax.swing.text.AttributeSet;
import javax.swing.*;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;

@SuppressWarnings("serial")
public class TextEdit extends JPanel implements ActionListener {
	
	private Style make_bolder; 
	private Style make_italic;
	private Style make_normal;
	private Style make_title;

	
	private final static String bold_string = "<html><center><b>" +
			"B</b></center>";
	private final static String italic_string = "<html><center>" +
			"<i>I</i></center>";
	private final static String normal_string = "<html><center>" +
			"N</center>";
	
	private final static String title_string = "<html><center>" +
			"H1</center>";
	
	JTextPane edit = new JTextPane();
	JButton button = new JButton("Salva");
	JButton bold = new JButton(bold_string);
	JButton italic = new JButton(italic_string);
	JButton normal = new JButton(normal_string);
	JButton title = new JButton(title_string);

	ClipboardPopupMenu clipBoard=ClipboardPopupMenu.installForComponent(edit);
	public TextEdit() {
		setLayout(null);
		setup();
		setClipboardMenu();
        add(edit); add(normal); add(button); add(bold); add(italic);
        add(title);

		inizializzaStili();
	}

	private void inizializzaStili() {

		make_bolder = edit.addStyle("bolder", null);
		StyleConstants.setBold(make_bolder, true);

		make_italic = edit.addStyle("italic", null);
		StyleConstants.setItalic(make_italic, true);
		
		make_normal = edit.addStyle("normal", null);
		StyleConstants.setItalic(make_normal, false);
		StyleConstants.setBold(make_normal, false);
		
		make_title = edit.addStyle("title", null);
		StyleConstants.setFontSize(make_title,22);
		StyleConstants.setFontFamily(make_title,"Verdana");
		

	}

	public void actionPerformed(ActionEvent e) {
	
		if(e.getActionCommand().compareTo("Salva")==0) {
			@SuppressWarnings("unused")
			SaveFileWindow save_file=new SaveFileWindow(edit.getText());
		}
		else if(e.getActionCommand().compareTo(bold_string)==0) {
			setSelectedTextStyle(make_bolder);
		} else if(e.getActionCommand().compareTo(italic_string)==0) {
			setSelectedTextStyle(make_italic);
		} else if(e.getActionCommand().compareTo(normal_string)==0) {
			setSelectedTextStyle(make_normal);
		} else if(e.getActionCommand().compareTo(title_string)==0) {
			setSelectedTextStyle(make_title);
		}
	}

	void setup() {
		setupEventi();
		normal.setBounds(30,30,50,30);
		bold.setBounds(80,30,50,30);
		italic.setBounds(130,30,50,30);
		title.setBounds(180,30,50,30);
		edit.setBounds(30,60,640,400);
		button.setBounds(30,460,640,50);
	}
	public void setupEventi() {
		bold.addActionListener(this);
		italic.addActionListener(this);
		button.addActionListener(this);
		normal.addActionListener(this);
		title.addActionListener(this);
	}
	public void setClipboardMenu() {
		clipBoard.addCopyFunction("Copia");
		clipBoard.addPasteFunction("Incolla");
		clipBoard.addCutFunction("Taglia");
		clipBoard.addClearFunction("Clear");
	}
	public String getPopupUrl(String causal) {
		String url=JOptionPane.showInputDialog("Inserisci url "+causal);
		return url;
	}
	/*private void setSelectedTextStyle(Style style) {
		int lunghezzaTestoSelezionato = edit.getSelectedText().length();
		int inizioSelezione = edit.getSelectionStart();
		Style ret=edit.getStyledDocument().getLogicalStyle(inizioSelezione);
		AttributeSet combine = style.copyAttributes();
		System.out.println(combine);
		if(combine != null) {
			ret.addAttributes(combine);
			System.out.println("$combine: no null value found");
		}
		if(combine == null) {
			ret.addAttributes(combine);
			System.out.println("$combine: null value found");
		}
		edit.getStyledDocument().setCharacterAttributes(inizioSelezione, 
				lunghezzaTestoSelezionato, 
				ret, true);
	}*/
	private void setSelectedTextStyle(Style style) {
		int lunghezzaTestoSelezionato = edit.getSelectedText().length();
		int inizioSelezione = edit.getSelectionStart();
		edit.getStyledDocument().setCharacterAttributes(inizioSelezione, 
				lunghezzaTestoSelezionato, 
				style, true);
	}

}