

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.IOException;

import javax.swing.*;
import javax.swing.border.TitledBorder;
import javax.swing.plaf.nimbus.NimbusLookAndFeel;
import javax.swing.text.html.HTMLEditorKit;

import Func.Global;
import MyraTools.RoundManager;



@SuppressWarnings("serial")
public class WorkSpace extends Frame {

   // variabili Menu
   Menu file= new Menu("File"); Menu edit= new Menu("Edit");
   Menu help= new Menu("Help"); Menu win= new Menu("Window");
   MenuBar barra = new MenuBar();
   String now_running = "HTML Visual Editor";
   // variabili dei pannelli
   Calc calc = new Calc();
   TitledBorder bordo_calc = BorderFactory.createTitledBorder("Calcola" +
   "trice");
   Appunti text = new Appunti();
   TitledBorder bordo_text = BorderFactory.createTitledBorder("Appunti");
   HtmlWidget html = new HtmlWidget();
   TitledBorder bordo_html = BorderFactory.createTitledBorder("Editor");
   Desktop desktop = new Desktop();
   TitledBorder bordo_desktop = BorderFactory.createTitledBorder("Desktop");
   TextEdit textedit = new TextEdit();
   TitledBorder bordo_textedit = BorderFactory.createTitledBorder("Text " +
   		"Editor");
   CodeEditor code = new CodeEditor();
   TitledBorder bordo_code = BorderFactory.createTitledBorder("Code Editor");
   JPanel other = new JPanel();
   TitledBorder bordo_other = BorderFactory.createTitledBorder("Other Tools");
   
   // costruttore del WorkSpace
   public WorkSpace(String title) { 
	try {
		UIManager.setLookAndFeel(new NimbusLookAndFeel());
	} catch (UnsupportedLookAndFeelException e) {
		e.printStackTrace();
	}
	// setup del menu
	other = setPanel(other);
	setupEventi();
	setLayout(null);
	setBackground(Color.gray);
	textedit.setVisible(false);
	code.setVisible(false);
	other.setVisible(new Boolean(false));
	setTitle(title);
	
	// attachement al menu
    file.add(Global.apri); file.add(Global.salva); 
    file.add(Global.chiudi); file.addSeparator();
    file.add("Menu Uscita"); file.addSeparator();
    file.add(Global.esci);
    textedit.edit.setEditorKit(new HTMLEditorKit());
    textedit.edit.setText("<html><b>");
    
    edit.add(Global.taglia); edit.add(Global.copia);edit.add(Global.incolla);
    edit.add(Global.cancella); edit.addSeparator(); edit.add(Global.cerca);
    edit.add(Global.rimpiazza); 
    
    win.add(Global.addwin); win.addSeparator();
    win.add(Global.calcpp); help.add(Global.aiuto); barra.add(file);
    barra.add(edit); barra.add(win); barra.setHelpMenu(help);
    
    setMenuBar(barra);
    add(calc); add(text); add(html); add(textedit);
    add(desktop); add(code); add(other);
    
    setupElementi();
    doLayout();
    pack();
    addWindowListener(new WorkSpaceWindowListener());
 }
 public void setupElementi() {
   calc.setBounds(80,100,220,300);
   calc.setBorder(bordo_calc);
   calc.setBackground(Color.gray);
   text.setBounds(80,420,220,200);
   text.setBorder(bordo_text);
   text.setBackground(Color.gray);
   html.setBounds(370,100,700,520);
   html.setBorder(bordo_html);
   html.setBackground(Color.gray);
   desktop.setBounds(1100,100,200,220);
   desktop.setBorder(bordo_desktop);
   desktop.setBackground(Color.gray);
   textedit.setBounds(370,100,700,520);
   textedit.setBorder(bordo_textedit);
   textedit.setBackground(Color.gray);
   code.setBounds(370,100,700,520);
   code.setBorder(bordo_code);
   code.setBackground(Color.gray);
   other.setBounds(370,100,700,520);
   other.setBorder(bordo_code);
   other.setBackground(Color.gray);
 }
 public static void Run()
 {
   WorkSpace new_wrk = new WorkSpace("");
   Dimension size = Toolkit.getDefaultToolkit().getScreenSize();
   new_wrk.setTitle("MagicStick(c) Myra Tools beta");
   new_wrk.setSize(size);
   new_wrk.setVisible(true);
 }
 class AscoltatoreMenu implements ActionListener
 {
   @SuppressWarnings("unused")
   public void actionPerformed (ActionEvent e) {
	 System.out.println(e.getActionCommand());
     if (e.getActionCommand().compareTo("Esci")==0) {
    	 System.exit(0);
     }
     else if(e.getActionCommand().compareTo("Nuova Area")==0) {
    	 WorkSpace new_space = new WorkSpace("MagicStick Myra Tools");
    	 new_space.setBounds(0,0,1760,720);
    	 new_space.setVisible(true);
     }
     else if(e.getActionCommand().compareTo("Calcolatrice")==0) {
    	 Finestramenu.Run();
     }
     else if(e.getActionCommand().compareTo("Visual HTML Editor")==0) {
		  html.setVisible(true);
    	  textedit.setVisible(false);
    	  code.setVisible(false);
    	  other.setVisible(false);
		  doLayout();
     }
     else if(e.getActionCommand().compareTo("Text Editor")==0) {
    	  textedit.setVisible(true);
   	      html.setVisible(false);
   	      code.setVisible(false);
    	  other.setVisible(false);
		  doLayout();
     }
     else if(e.getActionCommand().compareTo("Other Tools")==0) {
   	      other.setVisible(true);
   	      textedit.setVisible(false);
  	      html.setVisible(false);
  	      code.setVisible(false);
		  doLayout();
     }
     else if(e.getActionCommand().compareTo("Code Editor")==0) {
    	 code.setVisible(true);
    	 html.setVisible(false);
    	 textedit.setVisible(false);
  	     other.setVisible(false);
     }
     else if(e.getActionCommand().compareTo("Salva")==0) {
    	 if(isHTMLEditor()) {
    		 SaveFileWindow save = new 
    		 SaveFileWindow(html.htmlTextArea.getText());
    	 }
    	 else if(isVisualEditor()) {
    		 SaveFileWindow save = new
    		 SaveFileWindow(textedit.edit.getText());
         }
    	 else if(isCodeEditor()) {
    		 SaveFileWindow save = new
    		 SaveFileWindow(code.field.getText());
         }
     }
     if(e.getActionCommand().compareTo("Apri")==0) {
    	 SaveFileWindow save = new SaveFileWindow();
    	 File a = save.OpenFileWindow();
    	 String s = new String();
    	 if(isVisualEditor()) {
    		try {
				s = save.ReadFile(a.getAbsolutePath());
			} catch (IOException e1) {
				e1.printStackTrace();
			}
    		textedit.edit.setText(s);
    	 }
    	 else if(isHTMLEditor()){
     		try {
 				s = save.ReadFile(a.getAbsolutePath());
 			} catch (IOException e1) {
 				e1.printStackTrace();
 			}
     		html.htmlTextArea.setText(s);
    	 }
    	 else if(isCodeEditor()){
      		try {
  				s = save.ReadFile(a.getAbsolutePath());
  			} catch (IOException e1) {
  				e1.printStackTrace();
  			}
      		code.field.setText(s);
     	 }
     }
     else if(e.getActionCommand().compareTo("Chiudi")==0) {
    	 html.htmlTextArea.setText("");
    	 textedit.edit.setText("");
     }
     else if(e.getActionCommand().compareTo("Indice")==0) {
    	 Help.RunAll();
     }
   }
 }
 class WorkSpaceWindowListener implements WindowListener {
   public void windowActivated(WindowEvent e) {
     //System.out.println("WindowLoop@: Window Activated");
   }
   public void windowClosed(WindowEvent e) {
     //System.out.println("WindowLoop@: Window Closed");
   }
   public void windowClosing(WindowEvent e) {
     //System.out.println("WindowLoop@: Window Closing");
     System.exit(0);
   }
   public void windowDeactivated(WindowEvent e) {
     //System.out.println("WindowLoop@: Window Deactivaded");
   }
   public void windowDeiconified(WindowEvent e) {
     //System.out.println("WindowLoop@: Window Deiconified");
   }
   public void windowIconified(WindowEvent e) {
     //System.out.println("WindowLoop@: Window Iconified");
   }
   public void windowOpened(WindowEvent e) {
     //System.out.println("WindowLoop@: Window Opened");
   }
  }
  public void setDesktop(String desk) {
	  if(desk.compareTo("Text Editor")==0) {
		  now_running = "Visual Editor";
		  remove(html);
		  add(textedit);
		  doLayout();
	  }
	  if(desk.compareTo("HTML Visual Editor")==0) {
		  now_running = "HTML Visual Editor";
		  add(html);
		  remove(textedit);
		  doLayout();
	  }
	  if(desk.compareTo("Code Editor")==0) {
		  now_running = "Code Editor";
	  }
  }
  public boolean isVisualEditor() {
	  if(now_running.compareTo("Visual Editor")==0) {
		  return true;
	  }
	  else {
		  return false;
	  }
  }
  public boolean isHTMLEditor() {
	  if(now_running.compareTo("HTML Visual Editor")==0) {
		  return true;
	  }
	  else {
		  return false;
	  }
  }
  public boolean isCodeEditor() {
	  if(now_running.compareTo("Code Editor")==0) {
		  return true;
	  }
	  else {
		  return false;
	  }
  }
 // setup eventi menu
 void setupEventi() {
	 Global.apri.addActionListener(new AscoltatoreMenu());
	 Global.salva.addActionListener(new AscoltatoreMenu());
	 Global.chiudi.addActionListener(new AscoltatoreMenu());
	 Global.esci.addActionListener(new AscoltatoreMenu());
	 Global.taglia.addActionListener(new AscoltatoreMenu());
	 Global.copia.addActionListener(new AscoltatoreMenu());
	 Global.incolla.addActionListener(new AscoltatoreMenu());
	 Global.cancella.addActionListener(new AscoltatoreMenu());
	 Global.cerca.addActionListener(new AscoltatoreMenu());
	 Global.rimpiazza.addActionListener(new AscoltatoreMenu());
	 Global.aiuto.addActionListener(new AscoltatoreMenu());
	 Global.addwin.addActionListener(new AscoltatoreMenu());
	 Global.calcpp.addActionListener(new AscoltatoreMenu());
	 desktop.b1.addActionListener(new AscoltatoreMenu());
	 desktop.b2.addActionListener(new AscoltatoreMenu());
	 desktop.b3.addActionListener(new AscoltatoreMenu());
	 desktop.b4.addActionListener(new AscoltatoreMenu());
	 
 }
 public JPanel setPanel(JPanel p) {	
	 
	 p.setLayout(null);
	 // manager
	 RoundManager mng = new RoundManager();
	 mng.setBounds(30,30,250,300);
	 mng.setBackground(Color.gray);
	 TitledBorder bordo_mng = BorderFactory.createTitledBorder("" +
	 		"Round Manager");
	 mng.setBorder(bordo_mng);
	 
	 // parsare il pannello
	 p.add(mng);
	 return p;
 }

 }